//Elvtr_MISSION_ROOT = format ["mpmissions\%1.%2\", missionName, worldName];
ElvtrInitFilePath = __FILE__;
_SplitedPath = [ElvtrInitFilePath, "\"] call CBA_fnc_split;
_SplitedPath set [(count _SplitedPath) - 1,""];
ElvtrMainDirectory =  [_SplitedPath, "\"] call CBA_fnc_join;
ElvtrCabinMovementSoundPath = ElvtrMainDirectory + "sounds\CabinMovement_";
ElvtrFloorPositions = [20.0924,24.5424,28.992,33.442];//Initial ASL position of elevator floor.
if(isNil "ElvtrCurrentFloor")then
{
	ElvtrCurrentFloor = 1;//Variable is inteager value from 0 to 3. Server changes value and has responsibility about distribution to clients.
};
if(isNil "ElvtrDoorPosition")then
{
	ElvtrDoorPosition = 0;//Relative internal door position. Value 1 mean closed. Server edit value and public variable to clients
};
if(isNil "ElvtrCurrentSpeed")then
{
	ElvtrCurrentSpeed = 0;//Speed given by server to clients
};
if(isNil "AttachedMines")then
{
	AttachedMines = [];//Array to store reference to mones and explosives attached to the floor.
};
ElvtrMaxSpeed = 0.3;//Elevbator standard speed
ElvtrDowSpeedCoef = 0.7;//Speed reduction for descent. Descent is more buggy for walking player
ElvtrExternalDoors = [];//Will be filled in BuildCabinLocal.sqf script
ElvtrCallButtons = [ElvtrCall_0,ElvtrCall_1,ElvtrCall_2,ElvtrCall_3];//Rederence to call button objects.
ElvtrCallButtonsStatus = [false,false,false,false];//Memory array to store infomration about elevator user requests. (External buttons)
ElvtrConsoleButtonsStatus = [false,false,false,false];//Memory array to store infomration about elevator user requests. (Internal buttons)
ElvtrInternalDoorStartPosition = [-0.85,-0.6,0.24];//Relative position of internal elevator door when open to the main floor part.
ElvtrInternalDoorFinalPosition = [-0.85,0.7,0.24];//Relative position of internal elevator door when closed to the main floor part.
ElvtrExternalDoorStartPosition = [21967.672,21022.71];//2D postion of extrnal doors when opened.
ElvtrExternalDoorFinalPosition = [21968.630,21021.831];//2D postion of extrnal doors when closed.
ElvtrExternalDorRange = ElvtrExternalDoorStartPosition distance ElvtrExternalDoorFinalPosition;//Travel range in metres of the external doors from open to close position.
ElevtrExternalDoorVector = vectorNormalized( (ElvtrExternalDoorFinalPosition + [0]) vectorDiff (ElvtrExternalDoorStartPosition + [0]));//Direction to travel when closing.
ElvtrButtonBasicColour = "#(rgb,8,8,3)color(1,0,0,1.000000)";//Standard external button colour.
ElvtrPlayerDownSpeed = -0.4;//Speed in m/s which should be used to pin player to the floor when cabin move.
InternalBorders_NegativeLimit = [-0.83,-1.50];//Local minimal coordinate inside cabin of border rectangle.
InternalBorders_PositiveLimit = [1.25,1.45];//Local maximal coordinate inside cabin of border rectangle.

ElvtrRefreshPartPositions = compileFinal preprocessFile "elvtr\ElvtrRefreshPartPositions.sqf";//Prepare function which imitate attachto function but more fluently.
ElvtrIsObjectOnElevatorFloor = compileFinal preprocessFile "elvtr\ElvtrIsObjectOnElevatorFloor.sqf";//Prepare function which can decide whether is certain object on the elevator floor.
ElvtrTransferBackpackContent = compileFinal preprocessFile "elvtr\ElvtrTransferBackpackContent.sqf";//Prepare function which can transfer precisely transfer content from on backpack to other.

//Clent side function for calling elevator using external button.
ElvtrCall =
{
	_ButtonObject = _this select 0;
	_ButtonNameString = str _ButtonObject;
	_SplitResult = [_ButtonNameString, "_"] call CBA_fnc_split;
	_FloorNumber = parseNumber (_SplitResult select 1);

	_ButtonObject setObjectTextureGlobal [0, "#(rgb,8,8,3)color(0,1,0,1.000000)"];

	[-2, {
		ElvtrCallButtonsStatus set [_this,true];
		}, _FloorNumber] call CBA_fnc_globalExecute;

};

//Function for requesting foor using internal button.
ElvtrFloorRequest =
{
	private _WantedFloor = 0;
	if(isNil "ace_interact_menu_fnc_createAction")then
	{
		_WantedFloor = _this select 3;
	}
	else
	{
		_WantedFloor = _this select 2;
	};

	[-2, {
		ElvtrConsoleButtonsStatus set [_this,true];
		}, _WantedFloor] call CBA_fnc_globalExecute;
};



if(isNil "ace_interact_menu_fnc_createAction")then
{
	Elvtr_CallAction = ["Call elevator",ElvtrCall,[],1.5,true,true,"","true",1.2];
	Elvtr_0_Action = ["0th floor",ElvtrFloorRequest,0,1.5,true,true,"","true",1.2];
	Elvtr_1_Action = ["1st floor",ElvtrFloorRequest,1,1.5,true,true,"","true",1.2];
	Elvtr_2_Action = ["2nd floor",ElvtrFloorRequest,2,1.5,true,true,"","true",1.2];
	Elvtr_3_Action = ["3rd floor",ElvtrFloorRequest,3,1.5,true,true,"","true",1.2];

}
else
{
	Elvtr_CallAction = ["Call","Call elevator","",ElvtrCall,{true},{},[], [0,0,0], 1.2] call ace_interact_menu_fnc_createAction;//ACE action for external buttons.
	Elvtr_0_Action = ["0th","0th floor","",ElvtrFloorRequest,{true},{},0, [0,0,-0.15], 1.2] call ace_interact_menu_fnc_createAction;//ACE action as floor request for internal button (0th)
	Elvtr_1_Action = ["1st","1st floor","",ElvtrFloorRequest,{true},{},1, [0,0,-0.05], 1.2] call ace_interact_menu_fnc_createAction;//ACE action as floor request for internal button (1st)
	Elvtr_2_Action = ["2nd","2nd floor","",ElvtrFloorRequest,{true},{},2, [0,0,0.05], 1.2] call ace_interact_menu_fnc_createAction;//ACE action as floor request for internal button (2nd)
	Elvtr_3_Action = ["3rd","3rd floor","",ElvtrFloorRequest,{true},{},3, [0,0,0.15], 1.2] call ace_interact_menu_fnc_createAction;//ACE action as floor request for internal button (3rd)
};

ElvtrInternalConsoleOptions = [Elvtr_0_Action,Elvtr_1_Action,Elvtr_2_Action,Elvtr_3_Action];//Internal ACE actions as array

//Function to check wheter are all external door closed.
ElvtrCheckExterlalDoorsClosed =
{
	_ApproachLimit = 0.01;
	_AllDoorClosed = true;
	{
		_Position2D = [getpos _x select 0,getpos _x select 1];
		_Distance = _Position2D distance ElvtrExternalDoorFinalPosition;
		if(_Distance > _ApproachLimit)then
		{
			_AllDoorClosed = false;
		};
	} forEach ElvtrExternalDoors;
	_AllDoorClosed
};

[] call compile preprocessFile "elvtr\BuldCabinLocal.sqf";//Create local instance of cabin at each client in order to overcome server lags problem.
if(isNil "ElevatorHeight")then
{
	ElevatorHeight = getposASL Elvtr_Floor select 2;//Real value in metres. Variable is ised to sinchrinise cabin position across all clients.
}
else
{//Probaly JIP
	Elvtr_Floor setPosASL [getposASL Elvtr_Floor select 0,getposASL Elvtr_Floor select 1, ElevatorHeight];//Force position synchrinosation as player did JIP. Set position of the main elevator component.
	[] call  ElvtrRefreshPartPositions;//Refpresh position of the other components acording to position of the main component.
	[] call compileFinal preprocessFile "elvtr\ElvtrRefreshExternalDoorPositions.sqf";//External doors have not precise position after JIP so it has to be bixed.
};
[] call compile preprocessFile "elvtr\CloseDoors.sqf";//Make door closed as initial state. Server side script.
nic = [] execVM "elvtr\ElevatorSlave.sqf";//Run clientside script that syncronise door and elevator cabin position with the server.
nic = [] execVM "elvtr\ElevatorMannager.sqf";//Run server side manager for processing user inputs and managing elevator schedule.
nic = [] execVM "elvtr\CheckDropedObjects.sqf";//Server side process that detect and hadle nonhuman object inside elevator.

if(!isServer)then
{
	publicVariableServer "ElvtrCabinMovementSoundPath";//Path to the sound can be different at cilent so cielts will force server to use their path.
};
